import sys 
import numpy as np

n = len( sys.argv )
if n != 10 :
	print( "Args: cx cy cz  ox oy oz  ax ay ax" )
	sys.exit(1)

vc = np.zeros( (3,1) )
vo = np.zeros( (3,1) )
va = np.zeros( (3,1) )

vc[0,0] = float( sys.argv[1] )
vc[1,0] = float( sys.argv[2] )
vc[2,0] = float( sys.argv[3] )
 
vo[0,0] = float( sys.argv[4] )
vo[1,0] = float( sys.argv[5] )
vo[2,0] = float( sys.argv[6] )

va[0,0] = float( sys.argv[7] )
va[1,0] = float( sys.argv[8] )
va[2,0] = float( sys.argv[9] )

def calculaR( vc, vo, va ) :
	R = np.zeros( (3,3) )

	vb = vc - vo
	vz = vb/np.sqrt( vb.T @ vb )

	vb = np.cross( va, vz, axisa=0, axisb=0, axisc=0 )
	vx = vb/np.sqrt( vb.T @ vb )

	vy = np.cross( vz, vx, axisa=0, axisb=0, axisc=0 )

	R[0,:] = vx.T
	R[1,:] = vy.T
	R[2,:] = vz.T

	return R
	

def proyecta( p, P, R, vc ) :
	f = 1000
	u0 = 150
	v0 = 100
	K = np.array( [[-f, 0, u0 ], [0, -f, v0], [0, 0, 1]] )

	# El modelo de la cámara oscura
	# l p = K R [I| -c] P
	m, n = P.shape
	i = 0
	P1 = np.zeros( (3,1) )
	while i<n :
		P1[0,0] = P[0,i]
		P1[1,0] = P[1,i]
		P1[2,0] = P[2,i]

		P1[0,0] -= vc[0,0]
		P1[1,0] -= vc[1,0]
		P1[2,0] -= vc[2,0]

		p2 = K @ R @ P1

		# Homogeneizamos
		p[0,i] = p2[0,0]/p2[2,0]
		p[1,i] = p2[1,0]/p2[2,0]
		p[2,i] = 1

		i += 1

def imprime_proyeccion( p ) :
	# Imprime la cara 1
	print( p[0,0], p[1,0] )
	print( p[0,1], p[1,1] )
	print( p[0,2], p[1,2] )
	print( p[0,3], p[1,3] )
	print( p[0,0], p[1,0] )
	print( )

	# Imprime la cara 2
	print( p[0,4], p[1,4] )
	print( p[0,7], p[1,7] )
	print( p[0,6], p[1,6] )
	print( p[0,5], p[1,5] )
	print( p[0,4], p[1,4] )
	print( )

	print( p[0,0], p[1,0] )
	print( p[0,4], p[1,4] )
	print( )

	print( p[0,1], p[1,1] )
	print( p[0,5], p[1,5] )
	print( )

	print( p[0,2], p[1,2] )
	print( p[0,6], p[1,6] )
	print( )

	print( p[0,3], p[1,3] )
	print( p[0,7], p[1,7] )
	print( )


def cuboide( P, l1, l2, l3 ) :
	x = l1/2.0
	y = l2/2.0
	z = l3/2.0

	P[0,0] = x; P[1,0] = y; P[2,0] = z
	P[0,1] =-x; P[1,1] = y; P[2,1] = z
	P[0,2] =-x; P[1,2] =-y; P[2,2] = z
	P[0,3] = x; P[1,3] =-y; P[2,3] = z

	P[0,4] = x; P[1,4] = y; P[2,4] =-z
	P[0,5] =-x; P[1,5] = y; P[2,5] =-z
	P[0,6] =-x; P[1,6] =-y; P[2,6] =-z
	P[0,7] = x; P[1,7] =-y; P[2,7] =-z

# El modelo del cuboide son 8 puntos 3D
P = np.zeros( (3,8) )
# El modelo proyectado, está en 2D
p = np.zeros( (3,8) )

cuboide( P, 40, 20, 10 )
R = calculaR( vc, vo, va )
# print( R )
proyecta( p, P, R, vc )
imprime_proyeccion( p )
